/*
* name;
*/
var __spreadArrays = (this && this.__spreadArrays) || function () {
    for (var s = 0, i = 0, il = arguments.length; i < il; i++) s += arguments[i].length;
    for (var r = Array(s), k = 0, i = 0; i < il; i++)
        for (var a = arguments[i], j = 0, jl = a.length; j < jl; j++, k++)
            r[k] = a[j];
    return r;
};
var Handler = laya.utils.Handler;
var Main = /** @class */ (function () {
    function Main() {
        var _this = this;
        this.gameInit().then(function () {
            _this.createLoadingView();
        });
    }
    Main.prototype.gameInit = function () {
        var _this = this;
        //初始化微信小游戏
        Laya.MiniAdpter.init(true);
        //程序入口
        Laya.init(750, 1334, Laya.WebGL);
        // 
        // Laya.Stat.show();
        Laya.stage.scaleMode = Laya.Stage.SCALE_FIXED_WIDTH;
        Laya.stage.alignV = Laya.Stage.ALIGN_MIDDLE;
        Laya.stage.alignH = Laya.Stage.ALIGN_CENTER;
        console.log(Laya.Browser.clientWidth, Laya.Browser.clientHeight);
        //激活资源版本控制
        return new Promise(function (resolve, reject) {
            Laya.ResourceVersion.enable("version.json", Handler.create(_this, function () {
                resolve();
            }), Laya.ResourceVersion.FILENAME_VERSION);
        });
    };
    Main.prototype.createLoadingView = function () {
        var _this = this;
        Laya.loader.load(["res/atlas/assets/connect.atlas", "imgs/menu/new_bg.png"], Handler.create(this, function () {
            _this.loading = new ui.view.LoadingView2UI();
            Laya.stage.addChild(new view.BackGroundPage());
            view.BackGround.switchBackGround("imgs/menu/new_bg.png");
            _this.loading.centerX = 0;
            _this.loading.centerY = 0;
            Laya.stage.addChild(_this.loading);
            _this.resourceLoad().then(function () {
                _this.runGame();
            });
        }), null, null, 1, false, "preload");
    };
    Main.prototype.resourceLoad = function () {
        var _this = this;
        return new Promise(function (resolve, reject) {
            var arr = [];
            Object.getOwnPropertyNames(gameConst.soundList).forEach(function (key) {
                arr
                    .push(gameConst.soundList[key]);
            });
            var w = _this.loading.process.width - _this.loading.holder.width;
            console.log(w);
            var handler = new Handler(_this, function (progress) {
                _this.loading.process.value = progress;
                _this.loading.holder.x = progress * w;
            }, null, false);
            Laya.loader.load(__spreadArrays(arr, [gameConst.BMFontSource.Goal,
                gameConst.BMFontSource.Level,
                gameConst.BMFontSource.Props,
                gameConst.BMFontSource.Score,
                "starFx.part",
                "res/atlas/assets/gamepage.atlas",
                "res/atlas/imgs/gameMain.atlas",
                "res/atlas/imgs/menu.atlas",
                "res/atlas/imgs/dialog.atlas",
                "res/atlas/imgs/offline.atlas",
                "res/atlas/imgs/prop.atlas",
                "res/atlas/imgs/noprop.atlas",
                "assets/loading/loading.atlas",
                "assets/setting.json",
                "assets/imgs/gameMain/game_process$bar.png",
                "res/atlas/assets/mainpage.atlas"]), Handler.create(_this, function () {
                resolve();
                Laya.ResourceManager.systemResourceManager.autoRelease = true;
                // this.loadUser();
            }), handler);
        });
    };
    Main.prototype.runGame = function () {
        this.gameLayer = new Laya.Sprite();
        this.tipLayer = new Laya.Sprite();
        this.uiLayer = new Laya.View();
        this.uiLayer.size(750, 1334);
        var ec = new controller.EntryController();
        Laya.stage.removeChild(this.loading);
        this.loading.destroy();
        if (PageManager.init(this.gameLayer, this.tipLayer, this.uiLayer, Laya.stage)) {
            ec.init();
            //utils.EventHelper.fire(gameConst.UserInfoLoaded);
        }
        Global.remainRewardScore = "2000 - count*count*20";
        Global.stageGoalScore = "2000 * level - 1000";
    };
    Main.prototype.getGameSetting = function () {
        var guide = Laya.LocalStorage.getItem("IsGuide");
        gameSetting.Guide = !(guide);
        return utils.APIHelper.getSetting().then(function (res) {
            var jsonData = res;
            Global.Setting.welfare_cycle = jsonData.welfare_cycle;
            Global.Setting.today_prop = jsonData.today_prop;
            Global.testVersion = jsonData.testVersion;
            Global.Setting.switch_fav = jsonData.switch_fav === 1;
            Global.Setting.switch_follow = jsonData.switch_follow === 1;
            Global.Setting.switch_share = jsonData.switch_share === 1;
            Global.Setting.switch_video = jsonData.switch_video === 1;
            Global.Setting.video_time = jsonData.video_time;
            Global.Setting.video_time_new = jsonData.video_time_new;
            Global.Setting.reward_fav = jsonData.reward_fav;
            Global.Setting.reward_follow = jsonData.reward_follow;
            Global.Setting.switch_weekControl = jsonData.switch_weekControl == 1;
            Global.SaverMinCount = jsonData.saverMinCount;
            Global.remainRewardScore = jsonData.remainRewardScore ? jsonData.remainRewardScore : "2000 - $0*count*20";
            Global.stageGoalScore = jsonData.stageGoalScore ? jsonData.stageGoalScore : "2000 * $0 - 1000";
            Global.regionShareShield = jsonData.regionShareShield;
            Global.easyLevel = jsonData.easyLevel;
            Global.easyNum = jsonData.easyNum;
            if (Global.testVersion == Global.version) {
                Global.TrialShare = true;
            }
            else {
                Global.TrialShare = false;
            }
            //周六周日全分享，周一到周五全视频
            if (Global.Setting.switch_weekControl) {
                var date = new Date();
                var day = date.getDay();
                if (day == 0 || day == 6) {
                    Global.Setting.switch_video = false;
                }
                else {
                    Global.Setting.switch_video = true;
                }
            }
            var unit_id = JSON.parse(jsonData.unit_id);
            Global.rewardADID = unit_id[0].video;
            Global.bannerADID = unit_id[2].newbanner;
            Global.inviteDimondNum = jsonData.invite_reward;
            console.log("jsonData     ", jsonData);
            jsonData.prop.forEach(function (data) {
                switch (data.id) {
                    case "1":
                        Global.refreshProp = { id: data.id, name: data.name, price: parseInt(data.price) };
                        break;
                    case "2":
                        Global.bombProp = { id: data.id, name: data.name, price: parseInt(data.price) };
                        break;
                    case "3":
                        Global.brushProp = { id: data.id, name: data.name, price: parseInt(data.price) };
                        break;
                }
            });
            Object.getOwnPropertyNames(jsonData.shareinfo).forEach(function (key) {
                jsonData.shareinfo[key].forEach(function (data) {
                    Global.shareScene["s" + data.scenes].push({ id: data.id, scene: data.scenes, title: data.title, shareimg: data.shareimg });
                });
            });
            controller.EntryController.WXCTL.createVideoAd(Global.rewardADID);
            return utils.APIHelper.getGift();
        }).then(function (res) {
            Global.DailyList = res.list;
            var received = res.received;
            Global.GiftAble = received.today === 0;
            Global.ContinuityGet = received.days;
            return utils.APIHelper.luckyDraw();
        }).then(function (res) {
            Global.LuckyRewardList = res;
            //     return utils.APIHelper.offLine();
            // }).then((res) => {
            //     Global.OffLineRewardList = res;
            return Player.getUserData();
        }).then(function () {
            return utils.APIHelper.getRegion();
        }).then(function (res) {
            var data = JSON.parse(res);
            var region = data.result.prov;
            var regionArr = Global.regionShareShield.split(',');
            if (regionArr.indexOf(region) != -1) {
                Global.regionShare = true;
            }
            else {
                Global.regionShare = false;
            }
            Promise.resolve();
        });
    };
    Main.prototype.loadUser = function () {
        var _this = this;
        var self = this;
        var ec = new controller.EntryController();
        //登录
        controller.EntryController.WXCTL.login().then(function (res) {
            Global.code = res.code;
            utils.APIHelper.getOpenId(Global.code).then(function (res) {
                utils.token = res.token;
                Global.openid = res.openid;
                Global.uid = res.uid;
                console.log("login res   ", res);
                return self.getGameSetting();
            }).then(function () {
                Laya.stage.removeChild(self.loading);
                self.loading.destroy();
                if (PageManager.init(_this.gameLayer, _this.tipLayer, _this.uiLayer, Laya.stage)) {
                    ec.init();
                    utils.EventHelper.fire(gameConst.UserInfoLoaded);
                }
                return Promise.resolve();
            }).catch(function (e) {
                Laya.stage.removeChild(self.loading);
                self.loading.destroy();
                if (PageManager.init(_this.gameLayer, _this.tipLayer, _this.uiLayer, Laya.stage)) {
                    ec.init();
                    utils.EventHelper.fire(gameConst.UserInfoLoaded);
                }
                Global.remainRewardScore = "2000 - count*count*20";
                Global.stageGoalScore = "2000 * level - 1000";
            });
        }).catch(function (e) {
            console.log(e);
            if (PageManager.init(_this.gameLayer, _this.tipLayer, _this.uiLayer, Laya.stage)) {
                view.CustomTipDialog.showTip("登录游失败,请联系游戏开发者");
            }
        });
        controller.EntryController.WXCTL.showShareMenu();
    };
    return Main;
}());
new model.Player();
window.main = new Main();
;
//# sourceMappingURL=Main.js.map