var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
* name
*/
var controller;
(function (controller) {
    var LuckyDrawController = /** @class */ (function (_super) {
        __extends(LuckyDrawController, _super);
        function LuckyDrawController(page) {
            var _this = _super.call(this, page) || this;
            _this.page = page;
            return _this;
        }
        LuckyDrawController.prototype.onViewAddToStage = function () {
            utils.EventHelper.register(gameConst.OnButtonClick, this.onButtonClick, this);
        };
        LuckyDrawController.prototype.onViewRemovedFromStage = function () {
            utils.EventHelper.remove(gameConst.OnButtonClick, this.onButtonClick, this);
        };
        LuckyDrawController.prototype.onButtonClick = function (event, action) {
            var btnName = "";
            var self = this;
            switch (action) {
                case "BackMenu":
                    pageManager.back();
                    btnName = "返回主菜单";
                    break;
                case "FreeGet":
                    this.onFreeget();
                    btnName = "分享抽奖";
                    break;
                case "VideoGet":
                    this.onVideoGet();
                    btnName = "视频抽奖";
                    break;
                case "DoubleGet":
                    view.LoadingDialog.showLoading();
                    if (Global.TrialShare || Global.regionShare) {
                        self.playVideo().then(function () {
                            Player.instance.addWatchNum(Global.WatchVideoType.LuckyDoubleGet);
                            return Player.addItem(self.currentItem.type, self.currentItem.num * 2, false);
                        }).then(function () {
                            self.page.showLuckyPan();
                            view.LoadingDialog.hideLoading();
                            utils.EventHelper.fire(gameConst.RefreshProps);
                        }).catch(function () {
                            view.LoadingDialog.hideLoading();
                            self.page.showLuckyPan();
                            view.CustomTipDialog.showTip("视频获取失败");
                        });
                    }
                    else {
                        if (controller.EntryController.WXCTL.RewardADReady && Global.Setting.switch_video && Player.instance.getWatchNum(Global.WatchVideoType.LuckyDoubleGet)) {
                            self.playVideo().then(function () {
                                Player.instance.addWatchNum(Global.WatchVideoType.LuckyDoubleGet);
                                return Player.addItem(self.currentItem.type, self.currentItem.num * 2, false);
                            }).then(function () {
                                self.page.showLuckyPan();
                                view.LoadingDialog.hideLoading();
                                utils.EventHelper.fire(gameConst.RefreshProps);
                            }).catch(function () {
                                view.LoadingDialog.hideLoading();
                                self.page.showLuckyPan();
                                view.CustomTipDialog.showTip("视频获取失败");
                            });
                        }
                        else {
                            utils.EventHelper.once(gameConst.SharedCallBack, function (event, action, result) {
                                if (action === "DoubleGet" && result) {
                                    Player.addItem(self.currentItem.type, self.currentItem.num * 2, false)
                                        .then(function () {
                                        self.page.showLuckyPan();
                                        view.LoadingDialog.hideLoading();
                                        utils.EventHelper.fire(gameConst.RefreshProps);
                                    }).catch(function () {
                                        view.LoadingDialog.hideLoading();
                                        self.page.showLuckyPan();
                                        view.CustomTipDialog.showTip("道具添加失败");
                                    });
                                    Global.tureShare = false;
                                    Player.instance.addWatchNum(Global.WatchVideoType.LuckyDoubleGet);
                                }
                                else {
                                    view.LoadingDialog.hideLoading();
                                    self.page.showLuckyPan();
                                    if (Global.tureShare) {
                                        view.CustomTipDialog.showTip("到群里点击自己的分享链接领奖");
                                    }
                                    else {
                                        view.CustomTipDialog.showTip("分享失败");
                                    }
                                }
                            }, this);
                            controller.EntryController.WXCTL.shareHelp("DoubleGet");
                        }
                    }
                    btnName = "双倍领取";
                    break;
                case "CancelDoubleGet":
                    view.LoadingDialog.showLoading();
                    Player.addItem(self.currentItem.type, self.currentItem.num, false).then(function () {
                        self.page.showLuckyPan();
                        view.LoadingDialog.hideLoading();
                        utils.EventHelper.fire(gameConst.RefreshProps);
                    });
                    btnName = "直接领取";
                    break;
            }
            controller.EntryController.WXCTL.aldSendEvent("点击按钮", "按钮名称", btnName);
        };
        LuckyDrawController.prototype.onFreeget = function () {
            var self = this;
            utils.EventHelper.once(gameConst.SharedCallBack, function (event, action, result) {
                if (action === "GetLuckyDraw" && result)
                    self.doLuckyDraw().then(function (t) { return self.page.showReward(t); });
            }, this);
            controller.EntryController.WXCTL.shareHelp("GetLuckyDraw");
        };
        LuckyDrawController.prototype.playVideo = function () {
            var self = this;
            return new Promise(function (resolve, reject) {
                utils.EventHelper.fire(gameConst.PauseAudio);
                controller.EntryController.WXCTL.playVideoAD().then(function () {
                    utils.EventHelper.fire(gameConst.ResumeAudio);
                    resolve();
                }).catch(function (error) {
                    utils.EventHelper.fire(gameConst.ResumeAudio);
                    reject(error);
                });
            });
        };
        LuckyDrawController.prototype.onVideoGet = function () {
            var self = this;
            self.playVideo().then(function () {
                return self.doLuckyDraw();
            }).then(function (t) {
                self.page.showReward(t);
            }).catch(function (error) {
                view.CustomTipDialog.showTip(error);
            });
        };
        LuckyDrawController.prototype.doLuckyDraw = function () {
            var t = Math.floor(Math.random() * 8);
            var target = -t * 45 - 22.5 + 360 * 8;
            var self = this;
            return this.page.rotatePan(target, 5000).then(function () {
                self.currentItem = Global.LuckyRewardList[t];
                return Promise.resolve(t);
            });
        };
        return LuckyDrawController;
    }(controller.BaseController));
    controller.LuckyDrawController = LuckyDrawController;
})(controller || (controller = {}));
//# sourceMappingURL=LuckyDrawController.js.map