var model;
(function (model_1) {
    var GameModel = /** @class */ (function () {
        function GameModel() {
            this.cellCounter = 0;
            this.currentColCount = 0;
            this.curCleanList = [];
            this.duringClean = false;
            this.lightList = [];
            this.saver = false;
        }
        GameModel.prototype.newGame = function () {
            this.passed = false;
            this.cellsStage = [];
            this.cellsItemDic = new Dictionary();
            this.colInfos = [];
            this.init();
            this.updatedCol = [];
            this.curCleanList = [];
            this.saver = true;
            utils.EventHelper.fire(gameConst.GameInit);
        };
        GameModel.prototype.loadFromJson = function () {
            var _this = this;
            var temp = Laya.loader.getRes("assets/setting.json");
            this.cellsStage = [];
            //Global.currentScore = temp.currentScore;
            //Global.currentStage = temp.currentStage;
            //Global.lastStageScore = temp.lastStageScore;
            //Global.reviveTimes = temp.reviveTimes;
            this.passed = temp.passed;
            temp.cells.forEach(function (cell) {
                if (cell) {
                    var typ = "";
                    switch (cell.type) {
                        case 0:
                            typ = "star_model_red";
                            break;
                        case 1:
                            typ = "star_model_blue";
                            break;
                        case 2:
                            typ = "star_model_green";
                            break;
                        case 3:
                            typ = "star_model_yellow";
                            break;
                        case 4:
                            typ = "star_model_purple";
                            break;
                    }
                    var c = utils.Pool.getObjectFromPool(typ);
                    c.cellPosition(cell.x, cell.y, cell.selected);
                    c.removed = false;
                    _this.cellsStage.push(c);
                }
                else {
                    _this.cellsStage.push(null);
                }
            });
            this.colInfos = temp.colInfos;
            this.updatedCol = temp.updatedCol;
            this.curCleanList = temp.curCleanList;
            this.currentColCount = temp.currentColCount;
            temp = null;
            utils.EventHelper.fire(gameConst.GameInit);
        };
        GameModel.prototype.init = function () {
            var _this = this;
            this.currentColCount = 10;
            for (var i = 0; i < 10; i++) {
                var colinfo = new model.ColInfo();
                colinfo.count = 10;
                colinfo.index = i;
                colinfo.bottomPit = -1;
                colinfo.topPit = 10;
                colinfo.pitCount = 0;
                this.colInfos.push(colinfo);
            }
            var subTotal = 0;
            this.cellCounter = 100;
            /** 随机两个颜色个数为Global.easyLevel，其他3个颜色个数均分 */
            var index1;
            var index2;
            var tempArr = [0, 1, 2, 3, 4];
            var other;
            var other1 = -1;
            var numArr;
            if (Global.currentStage <= Global.easyLevel) {
                index1 = Math.floor(Math.random() * tempArr.length);
                tempArr.splice(index1, 1);
                index2 = tempArr[Math.floor(Math.random() * tempArr.length)];
                var last = 100 - Global.easyNum * 2;
                other = Math.floor(last / 3);
                if (last % 3 != 0) {
                    other1 = other + last % 3;
                }
                numArr = new Array();
                for (var i = 0; i < 5; i++) {
                    if (index1 == i || index2 == i) {
                        numArr.push(Global.easyNum);
                    }
                    else {
                        if (other1 != -1) {
                            numArr.push(other1);
                            other1 = -1;
                        }
                        else {
                            numArr.push(other);
                        }
                    }
                }
            }
            utils.quickWave().forEach(function (count, index) {
                if (Global.currentStage <= Global.easyLevel) {
                    count += numArr[index];
                }
                else {
                    count += 20;
                }
                var typ = "";
                while (--count >= 0) {
                    switch (index) {
                        case 0:
                            typ = "star_model_red";
                            break;
                        case 1:
                            typ = "star_model_blue";
                            break;
                        case 2:
                            typ = "star_model_green";
                            break;
                        case 3:
                            typ = "star_model_yellow";
                            break;
                        case 4:
                            typ = "star_model_purple";
                            break;
                    }
                    var cell = utils.Pool.getObjectFromPool(typ);
                    _this.cellsStage.push(cell);
                }
            });
            utils.Shuffle(this.cellsStage).forEach(function (cell, index) {
                var x = Math.floor(index % 10);
                var y = Math.floor(index / 10);
                cell.cellPosition(y, x);
            });
        };
        /**
         * 查找上边一块
         */
        GameModel.prototype.compareWithTop = function (pos_x, pos_y, type) {
            var index = this.caculateIndex(pos_x, (pos_y + 1));
            var cell = index < 100 ? this.cellsStage[index] : undefined;
            if (!cell || Math.floor(index / 10) > pos_x)
                return -1;
            else if (cell.cellType === type && cell.removed === false)
                return index;
            else
                return -1;
        };
        /**
         * 查找下边一块
         */
        GameModel.prototype.compareWithBottom = function (pos_x, pos_y, type) {
            var index = this.caculateIndex(pos_x, (pos_y - 1));
            var cell = index < 100 ? this.cellsStage[index] : undefined;
            if (!cell || index / 10 < pos_x) {
                return -1;
            }
            else if (cell.cellType === type && cell.removed === false) {
                return index;
            }
            else
                return -1;
        };
        /**
         * 查找左边一块
         */
        GameModel.prototype.compareWithLeft = function (pos_x, pos_y, type) {
            var index = this.caculateIndex(pos_x - 1, pos_y);
            var cell = index < 100 ? this.cellsStage[index] : undefined;
            if (!cell)
                return -1;
            else if (cell.cellType === type && cell.removed === false)
                return index;
            else
                return -1;
        };
        /**
         * 查找右边一块
         */
        GameModel.prototype.compareWithRight = function (pos_x, pos_y, type) {
            var index = this.caculateIndex(pos_x + 1, pos_y);
            var cell = index < 100 ? this.cellsStage[index] : undefined;
            if (!cell)
                return -1;
            else if (cell.cellType === type && cell.removed === false)
                return index;
            else
                return -1;
        };
        GameModel.prototype.hasNeighBour = function (pos_x, pos_y, type) {
            if (this.compareWithBottom(pos_x, pos_y, type) >= 0)
                return true;
            else if (this.compareWithRight(pos_x, pos_y, type) >= 0)
                return true;
            else if (this.compareWithTop(pos_x, pos_y, type) >= 0)
                return true;
            else if (this.compareWithLeft(pos_x, pos_y, type) >= 0)
                return true;
            else
                return false;
        };
        GameModel.prototype.deleteCell = function (index, count) {
            var cell = this.cellsStage[index];
            if (cell === undefined)
                return false;
            cell.removed = true;
            this.updateColInfo(cell.cellPosition_x, cell.cellPosition_y, cell.cellType);
            cell.reset();
            if (cell.onDelete)
                cell.onDelete.runWith({ cell: cell, score: Global.GetIndexScore(count) });
            var typ = "";
            switch (cell.cellType) {
                case 0:
                    typ = "star_model_red";
                    break;
                case 1:
                    typ = "star_model_blue";
                    break;
                case 2:
                    typ = "star_model_green";
                    break;
                case 3:
                    typ = "star_model_yellow";
                    break;
                case 4:
                    typ = "star_model_purple";
                    break;
            }
            cell.onColorChange = null;
            cell.onPositionChange = null;
            cell.onDelete = null;
            utils.Pool.collectObjectToPool(typ, cell);
            this.cellsStage[index] = undefined;
            this.cellCounter -= 1;
            return true;
        };
        //清除同颜色的星星
        GameModel.prototype.clean = function (pos_x, pos_y, type) {
            var _this = this;
            console.log(pos_x + "-" + pos_y + "-" + type);
            if (this.duringClean)
                return;
            //清理星星提示
            Laya.timer.clear(this, this.lightShow);
            var len = this.lightList.length;
            var cell;
            for (var j = 0; j < len; j++) {
                var k = this.lightList[j];
                cell = this.cellsStage[k];
                if (cell != undefined) {
                    cell.removed = false;
                    cell.offLight();
                }
                this.duringClean = false;
            }
            var count = 0;
            var cleanList = [];
            if (this.curCleanList.length > 0) {
                var temp = this.caculateIndex(pos_x, pos_y);
                if (this.curCleanList.indexOf(temp) >= 0) {
                    utils.EventHelper.fire(gameConst.CleanStars, this.curCleanList.length);
                    Global.sysBusy = true;
                    Laya.timer.once(100, this, this.stepClean.bind(this, 0));
                    return this.curCleanList.length;
                }
                else {
                    this.curCleanList.forEach(function (value) {
                        var _cell = _this.cellsStage[value];
                        if (_cell && _cell.removed) {
                            _cell.removed = false;
                            _cell.cellPosition(_cell.cellPosition_x, _cell.cellPosition_y, false);
                        }
                    });
                }
            }
            if (this.hasNeighBour(pos_x, pos_y, type) === false)
                return count;
            else {
                var sameCells = this.findSameTypeCells(pos_x, pos_y, type);
                cleanList.push(this.caculateIndex(pos_x, pos_y));
                while (true) {
                    var nextClean = [];
                    sameCells.forEach(function (index) {
                        var cell = _this.cellsStage[index];
                        if (cell !== undefined) {
                            nextClean.push.apply(nextClean, _this.findSameTypeCells(cell.cellPosition_x, cell.cellPosition_y, cell.cellType));
                            if (cleanList.indexOf(index) < 0) {
                                count++;
                                cell.removed = true;
                                cleanList.push(index);
                            }
                        }
                    });
                    if (nextClean.length <= 0)
                        break;
                    else
                        sameCells = nextClean;
                }
                this.curCleanList = cleanList;
                this.curCleanList.forEach(function (value) {
                    var _cell = _this.cellsStage[value];
                    _cell.removed = true;
                    _cell.cellPosition(_cell.cellPosition_x, _cell.cellPosition_y, true);
                });
                if (this.curCleanList.length > 0) {
                    this.clean(pos_x, pos_y, type);
                    utils.EventHelper.fire(gameConst.MultiClean);
                }
            }
            return count;
        };
        GameModel.prototype.findlightIndex = function (index) {
            var _this = this;
            this.lightList.splice(0);
            var cell = this.cellsStage[index];
            if (!cell)
                return;
            var count = 0;
            var sameCells = this.findSameTypeCells(cell.cellPosition_x, cell.cellPosition_y, cell.cellType);
            this.lightList.push(index);
            var _loop_1 = function () {
                var nextClean = [];
                sameCells.forEach(function (index) {
                    var cell = _this.cellsStage[index];
                    if (cell !== undefined) {
                        nextClean.push.apply(nextClean, _this.findSameTypeCells(cell.cellPosition_x, cell.cellPosition_y, cell.cellType));
                        if (_this.lightList.indexOf(index) < 0) {
                            count++;
                            cell.removed = true;
                            _this.lightList.push(index);
                        }
                    }
                });
                if (nextClean.length <= 0)
                    return "break";
                else
                    sameCells = nextClean;
            };
            while (true) {
                var state_1 = _loop_1();
                if (state_1 === "break")
                    break;
            }
            for (var i = 0; i < this.lightList.length; i++) {
                var index_1 = this.lightList[i];
                var cell_1 = this.cellsStage[index_1];
                cell_1.onLight();
            }
        };
        GameModel.prototype.stepClean = function (index) {
            var self = this;
            if (self.curCleanList.length <= index) {
                self.curCleanList = [];
                self.tampStage();
            }
            else {
                Global.currentScore2 += Global.GetIndexScore(index);
                utils.EventHelper.fire(gameConst.UpdateScore);
                if (Global.currentScore2 >= Global.GetStageGoal(Global.currentStage2) && !this.passed) {
                    this.passed = true;
                }
                var i = self.curCleanList[index];
                self.deleteCell(i, index);
                Laya.timer.once(50, self, self.stepClean.bind(self, index + 1));
            }
        };
        GameModel.prototype.stepCleanRemain = function (index) {
            var self = this;
            if (self.curCleanList.length <= index) {
                self.curCleanList = [];
                self.cellsStage = [];
                self.colInfos = [];
                self.updatedCol = [];
                Laya.timer.once(1500, self, function () {
                    if (self.passed) {
                        Global.currentStage++;
                        self.passed = false;
                        utils.EventHelper.fire(gameConst.UpdateStage);
                    }
                    else {
                        utils.EventHelper.fire(gameConst.StageFailed);
                    }
                });
            }
            else {
                this.freshRemainScore(index);
                var i = self.curCleanList[index];
                self.deleteCell(i, -1);
                Laya.timer.once(100, self, this.stepCleanRemain.bind(self, index + 1));
            }
        };
        //查找相同颜色的星星
        GameModel.prototype.findSameTypeCells = function (pos_x, pos_y, type) {
            return [
                this.compareWithBottom(pos_x, pos_y, type),
                this.compareWithTop(pos_x, pos_y, type),
                this.compareWithRight(pos_x, pos_y, type),
                this.compareWithLeft(pos_x, pos_y, type)
            ].filter(function (value) { return value >= 0; });
        };
        //更新要更新的列的信息
        GameModel.prototype.updateColInfo = function (pos_x, pos_y, type) {
            if (this.updatedCol.indexOf(pos_x) === -1) {
                this.updatedCol.push(pos_x);
            }
            var colinfo = this.colInfos[pos_x];
            if (colinfo != undefined) {
                colinfo.count--;
                colinfo.pitCount++;
                colinfo.topPit = Math.min(colinfo.topPit, pos_y);
                colinfo.bottomPit = Math.max(colinfo.bottomPit, pos_y);
            }
        };
        //计算在数组中的位置
        GameModel.prototype.caculateIndex = function (x, y) {
            return x * 10 + y;
        };
        GameModel.prototype.tampStage = function () {
            var _this = this;
            var emptyCol = [];
            var max = -1;
            var min = 10;
            this.updatedCol.forEach(function (col) {
                var result = _this.tampCol(col);
            });
            Laya.timer.once(100, this, function () {
                _this.tampSpaceCol();
                _this.updatedCol = [];
                var result = _this.check();
                if (result >= 0) {
                    if (gameSetting.curVersion !== Global.testVersion &&
                        _this.cellCounter != 0 &&
                        _this.cellCounter <= Global.SaverMinCount &&
                        !_this.passed &&
                        _this.saver &&
                        (controller.EntryController.WXCTL.RewardADReady || Global.Setting.switch_share)) {
                        _this.saver = false;
                        utils.EventHelper.fire(gameConst.SaverProps);
                    }
                    Laya.timer.once(100, _this, function () {
                        Global.sysBusy = false;
                    });
                }
            });
        };
        /**
         * 判断剩余的方块是否还有可消除的组合
         */
        GameModel.prototype.check = function () {
            var id;
            var list = this.cellsStage.filter(function (value) {
                return value;
            });
            var res = this.findCleanAble(list);
            Laya.timer.once(2000, this, this.lightShow, [res]);
            if (res >= 0)
                return res;
            this.calculateRemain(list);
            return -1;
        };
        /** 延迟显示提醒 */
        GameModel.prototype.lightShow = function (res) {
            if (res != -1) {
                this.findlightIndex(res);
            }
        };
        /**
         * 找出一组可消除的方块的坐标
         */
        GameModel.prototype.findCleanAble = function (list) {
            if (list.length <= 0)
                return -1;
            var index = Math.floor(Math.random() * list.length);
            for (var i = index; i < list.length; i++) {
                if (this.hasNeighBour(list[i].cellPosition_x, list[i].cellPosition_y, list[i].cellType))
                    return this.caculateIndex(list[i].cellPosition_x, list[i].cellPosition_y);
            }
            for (var i = index; i >= 0; i--) {
                if (this.hasNeighBour(list[i].cellPosition_x, list[i].cellPosition_y, list[i].cellType))
                    return this.caculateIndex(list[i].cellPosition_x, list[i].cellPosition_y);
            }
            return -1;
        };
        GameModel.prototype.calculateRemain = function (list) {
            var _this = this;
            list.forEach(function (cell) {
                _this.curCleanList.push(cell.cellPosition_x * 10 + cell.cellPosition_y);
            });
            Global.sysBusy = true;
            this.remain = 2000;
            Laya.timer.once(100, this, this.stepCleanRemain.bind(this, 0));
        };
        GameModel.prototype.freshRemainScore = function (index) {
            var totalRemain = this.curCleanList.length;
            this.remain += (-20 - 40 * index);
            if (this.remain <= 0)
                this.remain = 0;
            if (index + 1 == totalRemain) {
                Global.currentScore2 += this.remain;
                Global.lastStageScore = Global.currentScore2;
                this.passed = Global.currentScore2 >= Global.currentStage2;
            }
            utils.EventHelper.fire(gameConst.UpdateRemain, this.remain, true, totalRemain - index - 1);
        };
        /**
         * 压缩空列
         */
        GameModel.prototype.tampSpaceCol = function () {
            var _this = this;
            var emptyCol = [];
            var maxCol = -1;
            var minCol = 10;
            this.updatedCol.forEach(function (col) {
                var colinfo = _this.colInfos[col];
                if (colinfo.count === 0) {
                    emptyCol.push(col);
                    maxCol = Math.max(col, maxCol);
                    minCol = Math.min(col, minCol);
                }
            });
            var emCount = emptyCol.length;
            var colCount = this.currentColCount;
            if (emCount > 0) {
                // 为连续的空列
                if (emCount === 1 || (maxCol - minCol + 1) === emCount) {
                    if (maxCol !== colCount - 1) {
                        for (var i = maxCol + 1; i < colCount; i++) {
                            var colinfo = this.colInfos[i];
                            if (colinfo !== undefined) {
                                for (var j = 0; j < colinfo.count; j++) {
                                    var s_index = this.caculateIndex(i, j);
                                    var e_index = s_index - emCount * 10;
                                    var cell = this.cellsStage[e_index] = this.cellsStage[s_index];
                                    cell.cellPosition(i - emCount, j);
                                    delete this.cellsStage[s_index];
                                }
                                colinfo.index = i - emCount;
                                this.colInfos[i - emCount] = colinfo;
                                delete this.colInfos[i];
                            }
                        }
                    }
                }
                ///非连续的空列
                else {
                    var leftEmpty = minCol;
                    for (var i = minCol + 1; i < colCount; i++) {
                        var colinfo = this.colInfos[i];
                        var dis = i - leftEmpty;
                        if (colinfo.count > 0) {
                            for (var j = 0; j < colinfo.count; j++) {
                                var s_index = this.caculateIndex(i, j);
                                var e_index = s_index - dis * 10;
                                var cell = this.cellsStage[e_index] = this.cellsStage[s_index];
                                cell.cellPosition(i - dis, j);
                                delete this.cellsStage[s_index];
                            }
                            this.colInfos[leftEmpty] = colinfo;
                            delete this.colInfos[i];
                            leftEmpty++;
                        }
                    }
                }
            }
            this.currentColCount -= emCount;
        };
        /**
         * 压缩列
         */
        GameModel.prototype.tampCol = function (col) {
            var colinfo = this.colInfos[col];
            if (colinfo.pitCount > 0) {
                if (colinfo.bottomPit - colinfo.topPit + 1 === colinfo.pitCount) {
                    for (var i = colinfo.topPit; i < colinfo.count; i++) {
                        var s_index = this.caculateIndex(col, i);
                        var e_index = s_index + colinfo.pitCount;
                        var temp = this.cellsStage[e_index];
                        this.cellsStage[s_index] = temp;
                        temp.cellPosition(temp.cellPosition_x, temp.cellPosition_y - colinfo.pitCount);
                        delete this.cellsStage[e_index];
                    }
                }
                else {
                    var y = colinfo.topPit;
                    var bottomPitIndex = this.caculateIndex(col, y);
                    for (var i = colinfo.topPit; i < colinfo.count + colinfo.pitCount; i++) {
                        var s_index = this.caculateIndex(col, i);
                        var cell = this.cellsStage[s_index];
                        if (cell !== undefined) {
                            this.cellsStage[bottomPitIndex] = cell;
                            cell.cellPosition(col, y);
                            delete this.cellsStage[s_index];
                            y++;
                            bottomPitIndex = this.caculateIndex(col, y);
                        }
                    }
                }
            }
            if (colinfo.count === 0) {
                return true;
            }
            else {
                colinfo.pitCount = 0;
                colinfo.topPit = colinfo.count;
                colinfo.bottomPit = -1;
                return false;
            }
        };
        GameModel.prototype.saveGame = function () {
            if (!this.cellsStage)
                return;
            var model = {};
            model["curCleanList"] = this.curCleanList;
            model["currentColCount"] = this.currentColCount;
            model["passed"] = this.passed;
            model["updatedCol"] = this.updatedCol;
            model["colInfos"] = this.colInfos;
            var list = new Array(100);
            this.cellsStage.forEach(function (cell, index) {
                if (cell) {
                    list[index] = {
                        x: cell.cellPosition_x,
                        y: cell.cellPosition_y,
                        type: cell.cellType,
                        state: cell.cellState,
                        removed: cell.removed,
                        selected: cell.selected
                    };
                }
            });
            model["cells"] = list;
            return model;
        };
        GameModel.prototype.refreshAllCell = function () {
            var list = this.cellsStage.filter(function (cell) { return cell; });
            Global.sysBusy = true;
            list.forEach(function (element) {
                var index = Math.floor(Math.random() * list.length);
                var c = element.cellType;
                element.changeCellColor(list[index].cellType);
                list[index].changeCellColor(c);
            });
            Laya.timer.once(500, this, function () { return Global.sysBusy = false; });
        };
        return GameModel;
    }());
    model_1.GameModel = GameModel;
})(model || (model = {}));
//# sourceMappingURL=GameModel.js.map