/**
* name
*/
var model;
(function (model) {
    var Player = /** @class */ (function () {
        function Player() {
            // public userUse = {
            // 	Refresh: 0,
            // 	Bomb: 0,
            // 	Brush: 0
            // }
            this.diamondCount = 1000;
            this.refreshCount = 0;
            this.bombCount = 0;
            this.brushCount = 0;
            this.limit = 0;
            this.hasGot = 0;
            this.costDiamond = 0;
            Player.instance = this;
        }
        Object.defineProperty(Player.prototype, "DiamondCount", {
            get: function () {
                return this.diamondCount;
            },
            set: function (value) {
                this.diamondCount = value;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Player.prototype, "RefreshCount", {
            get: function () {
                return this.refreshCount;
            },
            set: function (value) {
                this.refreshCount = value;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Player.prototype, "BombCount", {
            get: function () {
                return this.bombCount;
            },
            set: function (value) {
                this.bombCount = value;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Player.prototype, "BrushCount", {
            get: function () {
                return this.brushCount;
            },
            set: function (value) {
                this.brushCount = value;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Player.prototype, "Limit", {
            get: function () {
                return 5;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(Player.prototype, "HasGot", {
            get: function () {
                return Laya.LocalStorage.getJSON(gameConst.Props_GetCount).count;
            },
            set: function (value) {
                var obj = Laya.LocalStorage.getJSON(gameConst.Props_GetCount);
                obj.count = obj.count + 1;
                if (obj.count > 5) {
                    obj.count = 5;
                }
                Laya.LocalStorage.setJSON(gameConst.Props_GetCount, obj);
            },
            enumerable: false,
            configurable: true
        });
        Player.prototype.useProps = function (id) {
            var itemCount = 0;
            switch (id) {
                case 1:
                    itemCount = this.RefreshCount;
                    if (itemCount > 0) {
                        this.refreshCount--;
                        //utils.APIHelper.useProp(1, 0, 0, 0);
                        return true;
                    }
                    else if (this.diamondCount >= 10) {
                        this.diamondCount -= 10;
                        //utils.APIHelper.useProp(0, 0, 0, 10);
                        return true;
                    }
                    break;
                case 2:
                    itemCount = this.BombCount;
                    if (itemCount > 0) {
                        this.bombCount--;
                        //utils.APIHelper.useProp(0, 1, 0, 0);
                        return true;
                    }
                    else if (this.diamondCount >= 10) {
                        this.diamondCount -= 10;
                        //utils.APIHelper.useProp(0, 0, 0, 10);
                        return true;
                    }
                    break;
                case 3:
                    itemCount = this.BrushCount;
                    if (itemCount > 0) {
                        this.brushCount--;
                        //utils.APIHelper.useProp(0, 0, 1, 0);
                        return true;
                    }
                    else if (this.diamondCount >= 10) {
                        this.diamondCount -= 10;
                        //utils.APIHelper.useProp(0, 0, 0, 10);
                        return true;
                    }
                    break;
            }
            return false;
        };
        Player.getUserData = function () {
            var p = this.instance;
            // p.userUse.Bomb = 0;
            // p.userUse.Refresh = 0;
            // p.userUse.Brush = 0;
            return utils.APIHelper.getUserInfo().then(function (data) {
                p.diamondCount = data.prop.diamond;
                p.bombCount = data.prop.bomb;
                p.refreshCount = data.prop.refresh;
                p.brushCount = data.prop.brush;
                p.limit = data.daily_receive.receive_limit;
                p.hasGot = data.daily_receive.receive_num;
                return Promise.resolve();
            });
        };
        Player.commitUserData = function () {
            return utils.APIHelper.updateScore(Global.currentScore);
        };
        Player.buyProp = function (prop) {
            var p = this.instance;
            return new Promise(function (resolve, reject) {
                utils.APIHelper.buyProp(prop.id).then(function () {
                    switch (prop.id) {
                        case "1":
                            p.refreshCount += 1;
                            break;
                        case "2":
                            p.bombCount += 1;
                            break;
                        case "3":
                            p.brushCount += 1;
                            break;
                    }
                    p.diamondCount -= prop.price;
                    resolve();
                    return model.Player.getUserData();
                }, function () { reject(); });
            });
        };
        Player.addItem = function (id, num, daily) {
            if (daily === void 0) { daily = false; }
            // return utils.APIHelper.increaseProps(id, num, daily).then(() => {
            // 	return Player.getUserData();
            // });
        };
        /**
         * 游戏中临时加道具 不发送给服务器
         */
        Player.addItemInGame = function (id) {
            var p = this.instance;
            switch (id) {
                case 1:
                    p.refreshCount += 1;
                    break;
                case 2:
                    p.bombCount += 1;
                    break;
                case 3:
                    p.brushCount += 1;
                    break;
            }
        };
        /**
         * 获取watchType类型观看视频次数是否已满
         * @param watchType 观看视频类型
         * @return true 还有次数  false 没有次数
         */
        Player.prototype.getWatchNum = function (watchType) {
            var date = new Date();
            var dateStr = date.getFullYear().toString() + ',' + (date.getMonth() + 1).toString() + ',' + date.getDate().toString();
            var dateValue = Laya.LocalStorage.getItem(watchType);
            if (dateValue == null) {
                Laya.LocalStorage.setItem(watchType, dateStr + ";0");
                return true;
            }
            else {
                var lastDate = dateValue.split(";");
                var times = Global.Setting.video_time_new.split(",");
                if (dateStr == lastDate[0]) {
                    var totalTimes = void 0;
                    var watchTimes = void 0;
                    //有视频可看
                    if (controller.EntryController.WXCTL.RewardADReady) {
                        totalTimes = parseInt(times[0]) + parseInt(times[1]) + parseInt(times[2]) + parseInt(times[3]);
                        watchTimes = parseInt(lastDate[1]) % totalTimes;
                        if (watchTimes >= parseInt(times[0]) && watchTimes < parseInt(times[0]) + parseInt(times[1]) || watchTimes >= parseInt(times[0]) + parseInt(times[1]) + parseInt(times[2])) {
                            //链接分享
                            if (watchTimes >= parseInt(times[0]) && watchTimes < parseInt(times[0]) + parseInt(times[1])) {
                                Global.tureShare = true;
                            }
                            else {
                                Global.tureShare = false;
                            }
                            return false;
                        }
                        else {
                            return true;
                        }
                    }
                    else {
                        //无视频可看 链接分享和伪分享循环
                        totalTimes = parseInt(times[1]) + parseInt(times[3]);
                        watchTimes = parseInt(lastDate[1]) % totalTimes;
                        if (watchTimes >= parseInt(times[1])) {
                            Global.tureShare = true;
                        }
                        else {
                            Global.tureShare = false;
                        }
                        return false;
                    }
                }
                else {
                    Laya.LocalStorage.setItem(watchType, dateStr + ";0");
                    return true;
                }
            }
        };
        /**
         * 增加对应类型观看视频次数 或 分享次数
         * @param watchType 观看视频类型 或 分享类型
         */
        Player.prototype.addWatchNum = function (watchType) {
            var dateValue = Laya.LocalStorage.getItem(watchType);
            var lastDate = dateValue.split(";");
            var times = Number(lastDate[1]);
            times++;
            Laya.LocalStorage.setItem(watchType, lastDate[0] + ";" + times.toString());
        };
        /**是否可获得离线奖励
         * @return true 有奖励  false 没奖励
         */
        Player.prototype.getOffLine = function () {
            var state;
            var lastTimeStr = Laya.LocalStorage.getItem("LastLoginTime");
            if (lastTimeStr == null) {
                state = false;
            }
            else {
                var lastTime = Number(lastTimeStr);
                if (Date.now() - lastTime >= Global.Setting.offLine_time * 3600000) {
                    state = true;
                }
                else {
                    state = false;
                }
            }
            Laya.LocalStorage.setItem("LastLoginTime", Date.now().toString());
            return state;
        };
        return Player;
    }());
    model.Player = Player;
})(model || (model = {}));
//# sourceMappingURL=Player.js.map