var model;
(function (model) {
    var StarCell = /** @class */ (function () {
        function StarCell(x, y) {
            this.cellType = 0;
            this.basecellType = 0;
            this.selected = false;
            this.removed = false;
            this.cellPosition(x, y);
        }
        Object.defineProperty(StarCell.prototype, "cellPosition_x", {
            get: function () {
                return this._cellPosition_x;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(StarCell.prototype, "cellPosition_y", {
            get: function () {
                return this._cellPosition_y;
            },
            enumerable: false,
            configurable: true
        });
        StarCell.prototype.cellPosition = function (x, y, selected) {
            if (selected === void 0) { selected = false; }
            if (x == this._cellPosition_x && y == this._cellPosition_y && selected == this.selected)
                return;
            this._cellPosition_x = x;
            this._cellPosition_y = y;
            this.selected = selected;
            if (this.onPositionChange) {
                this.onPositionChange(this);
            }
        };
        StarCell.prototype.changeCellColor = function (target) {
            this.cellType = target;
            this.onColorChange.runWith(target);
        };
        StarCell.prototype.reset = function () {
            this.cellType = this.basecellType;
            this.removed = false;
            this.selected = false;
        };
        return StarCell;
    }());
    model.StarCell = StarCell;
})(model || (model = {}));
//# sourceMappingURL=StarCell.js.map