var utils;
(function (utils) {
    var Event = laya.events.Event;
    var HttpRequest = laya.net.HttpRequest;
    utils.token = "";
    function HttpGet(url, header) {
        var _this = this;
        console.log("url   ", url);
        return new Promise(function (resolve, reject) {
            var request = new HttpRequest();
            request.once(Event.COMPLETE, _this, function (event) {
                resolve(request.data);
            });
            request.once(Event.ERROR, _this, function (event) {
                reject(event);
            });
            var headers = ["token", utils.token, "Content-Type", "application/json"];
            header && Object.getOwnPropertyNames(header).forEach(function (key) {
                headers.push(key, header[key]);
            });
            var data = "";
            request.send(url, null, "get", "text", headers);
        });
    }
    utils.HttpGet = HttpGet;
    function KeyValueData(postArgs) {
        var data = "";
        Object.getOwnPropertyNames(postArgs).forEach(function (key) {
            data += key + "=" + postArgs[key] + "&";
        });
        data.length > 0 && (data = data.slice(0, data.length - 1));
        return data;
    }
    function JsonData(postArgs) {
        return JSON.stringify(postArgs);
    }
    function requestSuc(e) {
        console.log(e.data);
    }
    utils.requestSuc = requestSuc;
    function HttpPost(url, postArgs, header, json) {
        var _this = this;
        if (json === void 0) { json = false; }
        return new Promise(function (resolve, reject) {
            var request = new HttpRequest();
            request.once(Event.COMPLETE, _this, function (event) {
                resolve(request.data);
            });
            request.once(Event.ERROR, _this, function (event) {
                reject(event);
            });
            var headers = ["token", utils.token, "Content-Type", "application/json"];
            Object.getOwnPropertyNames(header).forEach(function (key) {
                headers.push(key);
                headers.push(header[key]);
            });
            var data = json ? JsonData(postArgs) : KeyValueData(postArgs);
            request.send(url, data, "post", "application/json", headers);
            console.log(url + "?" + data);
        });
    }
    utils.HttpPost = HttpPost;
    var APIHelper;
    (function (APIHelper) {
        function getOpenId(code) {
            var url = gameConst.api.GET_OPENID.replace("code", code);
            return createPromise(utils.HttpGet(url));
        }
        APIHelper.getOpenId = getOpenId;
        /**
         * 获取系统配置
         */
        function getSetting() {
            return createPromise(utils.HttpGet(gameConst.api.GET_SETTING));
        }
        APIHelper.getSetting = getSetting;
        /**
         * 获取用户信息
         */
        function getUserInfo() {
            return createPromise(utils.HttpGet(gameConst.api.GET_USER_DETAIL));
        }
        APIHelper.getUserInfo = getUserInfo;
        /**
         * 提交成绩
         * @param score 成绩
         */
        function updateScore(score) {
            return createPromise(utils.HttpPost(gameConst.api.UPDATE_SCORE, { score: score }, {}, true));
        }
        APIHelper.updateScore = updateScore;
        function getGift() {
            return createPromise(utils.HttpGet(gameConst.api.DAILY_GIFT));
        }
        APIHelper.getGift = getGift;
        /**
         * 使用道具
         * @param type 道具类型 1刷新 2炸弹 3刷子
         */
        function useProp(refeshCount, bombCount, brushCount, diamond) {
            var data = [];
            refeshCount > 0 && data.push({
                type: 1,
                count: refeshCount
            });
            bombCount > 0 && data.push({
                type: 2,
                count: bombCount
            });
            brushCount > 0 && data.push({
                type: 3,
                count: brushCount
            });
            if (data.length <= 0 && diamond <= 0) {
                console.log("无可提交数据");
                return Promise.resolve();
            }
            return new Promise(function (resolve, reject) {
                var finish1, finish2 = false;
                var error = "none";
                var fun = function () {
                    if (finish1 && finish2) {
                        error === "none" ? resolve() : reject(error);
                    }
                };
                if (data.length > 0) {
                    createPromise(utils.HttpPost(gameConst.api.USE_PROPS, data, {}, true)).then(function () {
                        finish1 = true;
                        fun();
                    }).catch(function (e) {
                        error = e;
                        finish1 = true;
                        fun();
                    });
                }
                else {
                    finish1 = true;
                }
                if (diamond > 0) {
                    increaseProps(0, -diamond, false).then(function () {
                        finish2 = true;
                        fun();
                    }).catch(function (e) {
                        finish2 = true;
                        error = e;
                        fun();
                    });
                }
                else {
                    finish2 = true;
                }
            });
        }
        APIHelper.useProp = useProp;
        /**
         * 购买道具
         * @param id 道具ID
         */
        function buyProp(type) {
            return createPromise(utils.HttpPost(gameConst.api.BUY_PROPS, { propid: type }, {}, true));
        }
        APIHelper.buyProp = buyProp;
        /**
         * 分享奖励
         * @param site 场景
         * @param shareToken 分享者token
         */
        function verrifyShare(site, shareToken) {
            return createPromise(utils.HttpPost(gameConst.api.USER_SHARE, { site: site, share_token: shareToken }, {}, true));
        }
        APIHelper.verrifyShare = verrifyShare;
        /**
         * 通过分享链接进入游戏
         * @param uid  邀请人uid
         */
        function InviteShare(uid) {
            return createPromise(utils.HttpPost(gameSetting.ServerUrl + "/inviteLog", { invite_uid: uid }, {}, true));
        }
        APIHelper.InviteShare = InviteShare;
        /**
         * 用户邀请记录
         */
        function InviteRecord() {
            return createPromise(utils.HttpGet(gameSetting.ServerUrl + "/invite"));
        }
        APIHelper.InviteRecord = InviteRecord;
        /**
         * 用户领取邀请奖励
         * @param index 奖品index
         */
        function InviteReward(index) {
            return createPromise(utils.HttpPost(gameSetting.ServerUrl + "/invite", { invite_id: index }, {}, true));
        }
        APIHelper.InviteReward = InviteReward;
        /**
         * 授权给服务器
         */
        function PostDataAuthorize(head, name) {
            return createPromise(utils.HttpPost(gameSetting.ServerUrl + "/users/", { nickname: name, avatarurl: head }, {}, true));
        }
        APIHelper.PostDataAuthorize = PostDataAuthorize;
        /**
         * 增加道具
         * @param id 物品类型
         * @param num 数量
         */
        function increaseProps(id, num, daily) {
            return createPromise(utils.HttpPost(gameConst.api.INCREASE_PROP, { type: id, num: num, daily: daily ? 1 : 0 }, {}, true));
        }
        APIHelper.increaseProps = increaseProps;
        function luckyDraw() {
            return createPromise(utils.HttpGet(gameConst.api.TURN_TABLE, {}));
        }
        APIHelper.luckyDraw = luckyDraw;
        function offLine() {
            return createPromise(utils.HttpGet(gameConst.api.OFF_LINE, {}));
        }
        APIHelper.offLine = offLine;
        function dailyGift() {
            return createPromise(utils.HttpGet(gameConst.api.DAILY_GIFT, {}));
        }
        APIHelper.dailyGift = dailyGift;
        function encryotedGroup(iv, encryotedData) {
            return createPromise(utils.HttpPost(gameConst.api.ENCRYPTED_GROUP, { iv: iv, encryptedData: encryotedData }, {}, true)).then(function (data) { return Promise.resolve(data.openGId); });
        }
        APIHelper.encryotedGroup = encryotedGroup;
        /**获取自己的广告模块的信息 */
        function GetAdInfo() {
            return createPromise(utils.HttpGet(gameConst.api.CUSTOM_AD, {}));
        }
        APIHelper.GetAdInfo = GetAdInfo;
        /** 获取当前城市 */
        function getRegion() {
            return utils.HttpGet(gameSetting.getCurCity);
        }
        APIHelper.getRegion = getRegion;
        function createPromise(promise) {
            return promise.then(function (res) {
                var result = JSON.parse(res);
                var code = result.code;
                switch (code) {
                    case gameConst.api.errorCode.Failed:
                        console.log("gameConst.api.errorCode.Failed", res.msg);
                        return Promise.reject(result.msg);
                    case gameConst.api.errorCode.Success:
                        return Promise.resolve(result.data);
                    case gameConst.api.errorCode.InvalidToken:
                        return Promise.reject("用户身份错误");
                    case gameConst.api.errorCode.ServerExption:
                        return Promise.reject("服务器异常");
                    case gameConst.api.errorCode.NONE:
                        return Promise.reject("Options请求不做处理");
                    case gameConst.api.errorCode.AdSuccess:
                        return Promise.resolve(result.data);
                    default:
                        console.log("code  ", code);
                        return Promise.reject("系统错误");
                }
            });
        }
    })(APIHelper = utils.APIHelper || (utils.APIHelper = {}));
})(utils || (utils = {}));
//# sourceMappingURL=HttpUtils.js.map