// TypeScript file
var utils;
(function (utils) {
    function Shuffle(arr) {
        for (var i = arr.length - 1; i >= 0; i--) {
            var j = Math.floor(Math.random() * arr.length);
            var temp = arr[i];
            arr[i] = arr[j];
            arr[j] = temp;
        }
        return arr;
    }
    utils.Shuffle = Shuffle;
    function quickWave(n, crest, trough, isInteger) {
        if (n === void 0) { n = 5; }
        if (crest === void 0) { crest = 4; }
        if (trough === void 0) { trough = 4; }
        if (isInteger === void 0) { isInteger = true; }
        var list = [];
        // 无法进行波动均分，直接返回完全平分
        if (crest > (n - 1) * trough || trough > (n - 1) * crest) {
            return new Array(n);
        }
        var base = 0; // 最少需要消除的高度
        var wave = 0; // 波动量
        var high = crest; // 高位
        var low = -trough; // 低位
        var sum = 0; // 累计量
        var count = n; // 剩余数量
        while (--count >= 0) {
            // 动态当前的波动量
            if (crest > count * trough - sum) {
                high = count * trough - sum;
            }
            if (trough > count * crest + sum) {
                low = -sum - count * crest;
            }
            base = low;
            wave = high - low;
            var rnd = // 随机波动量
             void 0; // 随机波动量
            if (count > 0) {
                rnd = base + Math.random() * (wave + 1); // 随机波动
            }
            else {
                rnd = -sum;
            }
            if (isInteger === true) {
                rnd = Math.floor(rnd);
            }
            sum += rnd;
            list.push(rnd);
        }
        return list;
    }
    utils.quickWave = quickWave;
    utils._hasOwnProperty = Object.prototype.hasOwnProperty;
    utils.has = function (obj, prop) {
        return utils._hasOwnProperty.call(obj, prop);
    };
    /**
     * Default function to compare element order.
     * @function
     */
    function defaultCompare(a, b) {
        if (a < b) {
            return -1;
        }
        else if (a === b) {
            return 0;
        }
        else {
            return 1;
        }
    }
    utils.defaultCompare = defaultCompare;
    /**
     * Default function to test equality.
     * @function
     */
    function defaultEquals(a, b) {
        return a === b;
    }
    utils.defaultEquals = defaultEquals;
    /**
     * Default function to convert an object to a string.
     * @function
     */
    function defaultToString(item) {
        if (item === null) {
            return 'COLLECTION_NULL';
        }
        else if (isUndefined(item)) {
            return 'COLLECTION_UNDEFINED';
        }
        else if (isString(item)) {
            return '$s' + item;
        }
        else {
            return '$o' + item.toString();
        }
    }
    utils.defaultToString = defaultToString;
    /**
    * Joins all the properies of the object using the provided join string
    */
    function makeString(item, join) {
        if (join === void 0) { join = ','; }
        if (item === null) {
            return 'COLLECTION_NULL';
        }
        else if (isUndefined(item)) {
            return 'COLLECTION_UNDEFINED';
        }
        else if (isString(item)) {
            return item.toString();
        }
        else {
            var toret = '{';
            var first = true;
            for (var prop in item) {
                if (utils.has(item, prop)) {
                    if (first) {
                        first = false;
                    }
                    else {
                        toret = toret + join;
                    }
                    toret = toret + prop + ':' + item[prop];
                }
            }
            return toret + '}';
        }
    }
    utils.makeString = makeString;
    /**
     * Checks if the given argument is a function.
     * @function
     */
    function isFunction(func) {
        return (typeof func) === 'function';
    }
    utils.isFunction = isFunction;
    /**
     * Checks if the given argument is undefined.
     * @function
     */
    function isUndefined(obj) {
        return (typeof obj) === 'undefined';
    }
    utils.isUndefined = isUndefined;
    /**
     * Checks if the given argument is a string.
     * @function
     */
    function isString(obj) {
        return Object.prototype.toString.call(obj) === '[object String]';
    }
    utils.isString = isString;
    /**
     * Reverses a compare function.
     * @function
     */
    function reverseCompareFunction(compareFunction) {
        if (isUndefined(compareFunction) || !isFunction(compareFunction)) {
            return function (a, b) {
                if (a < b) {
                    return 1;
                }
                else if (a === b) {
                    return 0;
                }
                else {
                    return -1;
                }
            };
        }
        else {
            return function (d, v) {
                return compareFunction(d, v) * -1;
            };
        }
    }
    utils.reverseCompareFunction = reverseCompareFunction;
    /**
     * Returns an equal function given a compare function.
     * @function
     */
    function compareToEquals(compareFunction) {
        return function (a, b) {
            return compareFunction(a, b) === 0;
        };
    }
    utils.compareToEquals = compareToEquals;
})(utils || (utils = {}));
//# sourceMappingURL=Utils.js.map