var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/*
* SingleAdItem 单个广告块;
*/
var view;
(function (view) {
    var SingleAdItem = /** @class */ (function (_super) {
        __extends(SingleAdItem, _super);
        /**
         * @param: showType（展示的类型）: 0: drwer 抽屉式的 1:dualFloat 悬浮式 2：inter_a 内嵌式 3:youlike 猜你喜欢
         * @param: index:广告的索引
         */
        function SingleAdItem(showType, index) {
            var _this = _super.call(this) || this;
            _this.showType = showType;
            _this.index = index;
            return _this;
        }
        /**初始化*/
        SingleAdItem.prototype.Init = function () {
            this.InitData();
            this.InitView();
            this.InitEvent();
        };
        /**初始化数据*/
        SingleAdItem.prototype.InitData = function () {
            this.current_frame = 0;
            this.frames = [];
            this.source_arr = [];
        };
        /**初始化视图*/
        SingleAdItem.prototype.InitView = function () {
            this.GetResourceByData(GameData.AdData);
        };
        /**初始化事件*/
        SingleAdItem.prototype.InitEvent = function () {
            this.on(Laya.Event.MOUSE_DOWN, this, this.onclick);
        };
        /**设置position*/
        SingleAdItem.prototype.SetPosition = function (posX, posY) {
            this.pos(posX, posY);
        };
        /**当被点击*/
        SingleAdItem.prototype.onclick = function () {
            //platform.navigateToMiniProgram(this.appId);
            // controller.EntryController.WXCTL.aldSendEvent.AldNavigateToMiniProgram(this.appId,{showType:GameData.AdData[this.showType].type,appName:this.appname});
            controller.EntryController.WXCTL.aldSendEvent(GameData.AdData[this.showType].type, "click", this.appname);
        };
        /**得到动画所用的资源 */
        SingleAdItem.prototype.GetResourceByData = function (data) {
            var adContent = data[this.showType].content;
            var adWidth = parseInt(data[this.showType].width);
            var adHeight = parseInt(data[this.showType].height);
            var currentContent = adContent[this.index];
            this.id = currentContent.id;
            this.appId = currentContent.appid;
            this.path = currentContent.path;
            this.appname = currentContent.appname;
            var url = currentContent.image;
            Laya.loader.load(url, Laya.Handler.create(this, function (res) {
                this.textureNum = currentContent.frame;
                var f = [];
                for (var i = 0; i < this.textureNum; i++) {
                    var posX = Math.floor(i % 3) * adWidth;
                    var posY = Math.floor(i / 3) * adHeight;
                    var texture = laya.resource.Texture.createFromTexture(res, posX, posY, adWidth, adHeight);
                    this.source_arr.push(texture);
                    f.push(i);
                }
                this.SetFrames(f);
                if (this.textureNum == 1) {
                    this.Img_Ad.source = this.source_arr[this.frames[this.current_frame]];
                }
                else {
                    Laya.timer.frameLoop(5, this, this.SetResource);
                }
                this.SetDetailInfo();
            }));
        };
        /**阿拉丁显示埋点 */
        SingleAdItem.prototype.AldShowEvent = function () {
            //发送阿拉丁埋点
            //GameData.AldSendEvent(GameData.AdData[this.showType].type, "show", "show");
            controller.EntryController.WXCTL.aldSendEvent(GameData.AdData[this.showType].type, "show", this.appname);
        };
        /**添加圆角矩形遮罩 */
        SingleAdItem.prototype.AddRoundedRectangleMask = function () {
            var mask = new Laya.Sprite();
            // 圆角 10
            var path = [
                ["moveTo", 20, 0],
                ["arcTo", this.Img_Ad.width, 0, this.Img_Ad.width, 20, 20],
                ["arcTo", this.Img_Ad.width, this.Img_Ad.height, this.Img_Ad.width - 20, this.Img_Ad.height, 20],
                ["arcTo", 0, this.Img_Ad.height, 0, this.Img_Ad.height - 20, 20],
                ["arcTo", 0, 0, 20, 0, 20],
            ];
            mask.graphics.drawPath(0, 0, path, { fillStyle: "#ffffff" });
            this.Img_Ad.mask = mask;
        };
        /**添加标题圆角*/
        SingleAdItem.prototype.AddRectRoundedRectangleMask = function () {
            var mask = new Laya.Sprite();
            var width = this.Img_Ad.width;
            var height = this.height - this.width;
            // 圆角 10
            var path = [
                ["moveTo", 15, 0],
                ["arcTo", width, 0, width, 15, 15],
                ["arcTo", width, height, width - 15, height, 15],
                ["arcTo", 0, height, 0, height - 15, 15],
                ["arcTo", 0, 0, 15, 0, 15],
            ];
            mask.graphics.drawPath(0, 0, path, { fillStyle: "#C83259" }, { "strokeStyle": "#FE768F", "lineWidth": "2" });
            this.Box_Title.addChildAt(mask, 0);
            this.Box_Title.y = this.width + 5;
            //this.sp.mask = mask;
        };
        /**添加圆形遮罩 */
        SingleAdItem.prototype.AddCircleMask = function () {
            //创建遮罩对象
            var mask = new Laya.Sprite();
            //画一个圆形的遮罩区域
            mask.graphics.drawCircle(this.width / 2, this.width / 2, this.width / 2, "#ff0000");
            //实现img显示对象的遮罩效果
            this.Img_Ad.mask = mask;
        };
        /**设置广告的细节信息 */
        SingleAdItem.prototype.SetDetailInfo = function () {
            this.Label_AppName.text = this.appname;
            switch (this.showType) {
                /**如果是抽屉式的 */
                case 0:
                    if (this.Box_Tip.visible == false) {
                        this.Box_Tip.visible = true;
                    }
                    this.Label_AppName.font = "Helvetica";
                    this.Label_AppName.fontSize = (this.height - this.width) - 10;
                    this.AddRoundedRectangleMask();
                    break;
                /**如果是悬浮式的 */
                case 1:
                    if (this.Box_Tip.visible == false) {
                        this.Box_Tip.visible = true;
                    }
                    this.AddRectRoundedRectangleMask();
                    // this.sp = new Laya.Sprite();
                    // this.sp.graphics.drawRect(0, 0, this.Img_Ad.width, (this.height - this.width), "#C83259");
                    // this.Box_Title.addChildAt(this.sp, 0);
                    this.Label_AppName.font = "Helvetica";
                    this.Label_AppName.fontSize = (this.height - this.width) - 20;
                    this.Label_AppName.color = "#ffffff";
                    this.AddRoundedRectangleMask();
                    break;
                /**如果是插屏式的 */
                case 2:
                    if (this.Box_Tip.visible == true) {
                        this.Box_Tip.visible = false;
                    }
                    this.mask = null;
                    this.sp = new Laya.Sprite();
                    var color = "";
                    if (this.index % 2 == 0) {
                        color = "#C83259";
                    }
                    else {
                        color = "#D8A744";
                    }
                    this.sp.graphics.drawRect(0, 0, this.Img_Ad.width, (this.height - this.width), color);
                    //console.log(this.Img_Ad.width);
                    this.Box_Title.addChildAt(this.sp, 0);
                    this.Label_AppName.font = "Helvetica";
                    this.Label_AppName.fontSize = this.height - this.width - 20;
                    this.Label_AppName.color = "#FFFFFF";
                    break;
                /**如果是猜你喜欢的 */
                case 3:
                    if (this.Box_Tip.visible == true) {
                        this.Box_Tip.visible = false;
                    }
                    this.Label_AppName.font = "Helvetica";
                    this.Label_AppName.fontSize = (this.height - this.width) - 10;
                    this.AddCircleMask();
                    break;
                default:
                    console.log("位置显示类型，请确认showType");
                    break;
            }
        };
        /**设置大小 */
        SingleAdItem.prototype.SetAdSize = function (width, height) {
            this.width = width;
            this.height = height;
            this.Img_Ad.width = width;
            this.Img_Ad.height = width;
            this.Box_Title.width = width;
            this.Box_Title.y = width;
            this.Box_Title.height = height - width;
            this.Label_AppName.width = width;
            this.Label_AppName.height = height - width;
            if (this.sp != null) {
                this.sp.width = width;
                this.sp.height = height - width;
            }
        };
        SingleAdItem.prototype.Clear = function () {
        };
        /**设置帧图的顺序和速率 */
        SingleAdItem.prototype.SetFrames = function (f) {
            this.frames = f;
        };
        /**每一帧设置资源( )*/
        SingleAdItem.prototype.SetResource = function () {
            var f = this.frames[this.current_frame];
            this.Img_Ad.source = this.source_arr[f];
            if (this.current_frame >= (this.frames.length - 1)) {
                this.current_frame = 0;
            }
            this.current_frame++;
        };
        return SingleAdItem;
    }(ui.view.CustomAd.SingleAdDialogUIUI));
    view.SingleAdItem = SingleAdItem;
})(view || (view = {}));
//# sourceMappingURL=SingleAdItem.js.map