var __extends = (this && this.__extends) || (function () {
    var extendStatics = function (d, b) {
        extendStatics = Object.setPrototypeOf ||
            ({ __proto__: [] } instanceof Array && function (d, b) { d.__proto__ = b; }) ||
            function (d, b) { for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p]; };
        return extendStatics(d, b);
    };
    return function (d, b) {
        extendStatics(d, b);
        function __() { this.constructor = d; }
        d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
    };
})();
/**
* name
*/
var view;
(function (view) {
    var GameRankPage = /** @class */ (function (_super) {
        __extends(GameRankPage, _super);
        function GameRankPage() {
            var _this = _super.call(this) || this;
            _this.shown = false;
            _this.sharedCanvas.on(Laya.Event.CLICK, _this, function () { });
            _this.background.on(Laya.Event.CLICK, _this, function () {
                _this.closeRankList();
                PageManager.getInstance().back();
            });
            _this.groupRank.on(Laya.Event.CLICK, _this, function () { return utils.EventHelper.fire(gameConst.OnButtonClick, "ShowGroupRank"); });
            return _this;
        }
        GameRankPage.prototype.showPage = function (data) {
            var _this = this;
            if (this.shown)
                return;
            var self = this;
            return new Promise(function (resolve, reject) {
                view.CreateTween(self.rankGroup, { scaleX: 1, scaleY: 1, alpha: 1 }, Global.PageAnimatorDuration, Handler.create(_this, function () {
                    resolve();
                    Laya.Browser.onMiniGame && _this.showRankList();
                    self.shown = true;
                }));
                view.BackGround.showMask();
            });
        };
        GameRankPage.prototype.hidePage = function () {
            if (!this.shown)
                return;
            var self = this;
            return new Promise(function (resolve, reject) {
                view.CreateTween(self.rankGroup, { scaleX: 0, scaleY: 0, alpha: 0 }, Global.PageAnimatorDuration, Handler.create(self, function () {
                    Global.sharedTexture.bitmap.alwaysChange = false;
                    resolve();
                    self.shown = false;
                }));
                view.BackGround.hideMask();
            });
        };
        Object.defineProperty(GameRankPage.prototype, "target", {
            get: function () {
                return this;
            },
            enumerable: false,
            configurable: true
        });
        Object.defineProperty(GameRankPage.prototype, "pageName", {
            get: function () {
                return Global.Pages.RankPage;
            },
            enumerable: false,
            configurable: true
        });
        GameRankPage.prototype.getGroupRank = function (res) {
            Laya.Browser.window.wx.getOpenDataContext().postMessage({
                message: JSON.stringify({
                    shareTicket: res,
                    tag: "showGroupRank"
                })
            });
        };
        GameRankPage.prototype.closeRankList = function () {
            if (Laya.Browser.onMiniGame) {
                Laya.Browser.window.wx.getOpenDataContext().postMessage({
                    message: JSON.stringify({
                        isDisplay: false,
                        year: (new Date()).getFullYear(),
                        tag: "closeRankView"
                    })
                });
                Global.sharedTexture.bitmap.alwaysChange = false; //开启
                Global.sharedTexture.destroy(true);
            }
        };
        GameRankPage.prototype.showRankList = function () {
            this.sharedCanvas.graphics.clear();
            //主域向子域发送自定义消息
            Laya.Browser.window.wx.getOpenDataContext().postMessage({
                message: JSON.stringify({ tag: "showRankView" })
            });
            Global.CreateSharedTexture(640, 820);
            Global.sharedTexture.bitmap.alwaysChange = true; //开启后很耗资源，需要显示排行榜时开启
            this.sharedCanvas.texture = Global.sharedTexture;
        };
        return GameRankPage;
    }(ui.view.GameRankPageViewUI));
    view.GameRankPage = GameRankPage;
})(view || (view = {}));
//# sourceMappingURL=GameRankPage.js.map